Index: trunk/SophyaPI/PIext/exclude
===================================================================
--- trunk/SophyaPI/PIext/exclude	(revision 563)
+++ trunk/SophyaPI/PIext/exclude	(revision 584)
@@ -1,2 +1,3 @@
+nomtmatvecadapter.cc
 modrecst.cc
 userfitfunex.c
Index: trunk/SophyaPI/PIext/exclude_dpc
===================================================================
--- trunk/SophyaPI/PIext/exclude_dpc	(revision 563)
+++ trunk/SophyaPI/PIext/exclude_dpc	(revision 584)
@@ -1,4 +1,5 @@
 modrecst.cc
 userfitfunex.c
+nommatvecadapter.cc
 nomstladapter.cc
 pistlist.cc
Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 563)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 584)
@@ -768,9 +768,7 @@
 #else
   s.GotoTagNum(i);
+  nom = s.GetTagName(i);
   try {
     obj = s.ReadObject();
-    char buffnom[64];
-    sprintf(buffnom,"O%d",i);
-    nom = buffnom;
   }
   catch (IOExc iox) {
Index: trunk/SophyaPI/PIext/nomhistadapter.cc
===================================================================
--- trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 563)
+++ trunk/SophyaPI/PIext/nomhistadapter.cc	(revision 584)
@@ -51,6 +51,6 @@
 mHis->Write(pos,0,tag);
 #else
-string s = typeid(*mObj).name();
-cout << "NOMAdapter_Histo::SavePPF() - Error : Not supported for " << s << endl;
+ObjFileIO<Histo> fio(mHis);
+fio.Write(pos, nom);
 #endif
 }
@@ -169,6 +169,6 @@
 mHis->Write(pos,0,tag);
 #else
-string s = typeid(*mObj).name();
-cout << "NOMAdapter_Histo2D::SavePPF() - Error : Not supported for " << s << endl;
+ObjFileIO<Histo2D> fio(mHis);
+fio.Write(pos, nom);
 #endif
 }
@@ -297,6 +297,6 @@
 mNt->Write(pos,0,tag);
 #else
-string s = typeid(*mObj).name();
-cout << "NOMAdapter_NTuple::SavePPF() - Error : Not supported for " << s << endl;
+ObjFileIO<NTuple> fio(mNt);
+fio.Write(pos, nom);
 #endif
 }
Index: trunk/SophyaPI/PIext/piinit.cc
===================================================================
--- trunk/SophyaPI/PIext/piinit.cc	(revision 563)
+++ trunk/SophyaPI/PIext/piinit.cc	(revision 584)
@@ -5,10 +5,17 @@
 #include "nomhistadapter.h"
 #include "nomgfdadapter.h"
-#include "nommatvecadapter.h"
 #include "nomimagadapter.h"
 
 #ifdef SANS_EVOLPLANCK
+#include "nommatvecadapter.h"
 #include "fitsimage.h"
 #include "nomstladapter.h"
+#else
+#include <complex>
+#include "nomtmatvecadapter.h"
+#include "nomskymapadapter.h"
+#include "spherethetaphi.h"
+#include "spheregorski.h"
+#include "localmap.h"
 #endif
 
@@ -36,6 +43,19 @@
   serv->RegisterClass(new GeneralFitData, new NOMAdapter_GeneralFitData );
 
+#ifdef SANS_EVOLPLANCK
   serv->RegisterClass(new Vector, new NOMAdapter_Vector );
   serv->RegisterClass(new Matrix, new NOMAdapter_Matrix );
+#else
+  serv->RegisterClass(new TVector<int_4>, new NOMAdapter_TMatrix<int_4> );
+  serv->RegisterClass(new TMatrix<int_4>, new NOMAdapter_TMatrix<int_4> );
+  serv->RegisterClass(new TVector<r_4>, new NOMAdapter_TMatrix<r_4> );
+  serv->RegisterClass(new TMatrix<r_4>, new NOMAdapter_TMatrix<r_4> );
+  serv->RegisterClass(new TVector<r_8>, new NOMAdapter_TMatrix<r_8> );
+  serv->RegisterClass(new TMatrix<r_8>, new NOMAdapter_TMatrix<r_8> );
+  serv->RegisterClass(new TVector<complex<float> >, new NOMAdapter_TMatrix<complex<float> > );
+  serv->RegisterClass(new TMatrix<complex<float> >, new NOMAdapter_TMatrix<complex<float> > );
+  serv->RegisterClass(new TVector<complex<double> >, new NOMAdapter_TMatrix<complex<double> > );
+  serv->RegisterClass(new TMatrix<complex<double> >, new NOMAdapter_TMatrix<complex<double> > );
+#endif
 
   serv->RegisterClass(new Image<uint_2>, new  NOMAdapter_Image<uint_2> );
@@ -51,4 +71,18 @@
 
   serv->RegisterClass(new StarList, new NOMAdapter_StarList );
+#else
+  serv->RegisterClass(new LocalMap<r_4>, new NOMAdapter_PixelMap<r_4> );
+  serv->RegisterClass(new SphereThetaPhi<r_4>, new NOMAdapter_PixelMap<r_4> );
+  serv->RegisterClass(new SphereGorski<r_4>, new NOMAdapter_PixelMap<r_4> );
+  serv->RegisterClass(new LocalMap<r_8>, new NOMAdapter_PixelMap<r_8> );
+  serv->RegisterClass(new SphereThetaPhi<r_8>, new NOMAdapter_PixelMap<r_8> );
+  serv->RegisterClass(new SphereGorski<r_8>, new NOMAdapter_PixelMap<r_8> );
+  serv->RegisterClass(new LocalMap<complex<float> >, new NOMAdapter_PixelMap<complex<float> > );
+  serv->RegisterClass(new SphereThetaPhi<complex<float> >, new NOMAdapter_PixelMap<complex<float> > );
+  serv->RegisterClass(new SphereGorski<complex<float> >, new NOMAdapter_PixelMap<complex<float> > );
+  serv->RegisterClass(new LocalMap<complex<double> >, new NOMAdapter_PixelMap<complex<double> > );
+  serv->RegisterClass(new SphereThetaPhi<complex<double> >, new NOMAdapter_PixelMap<complex<double> > );
+  serv->RegisterClass(new SphereGorski<complex<double> >, new NOMAdapter_PixelMap<complex<double> > );
+
 #endif
 
Index: trunk/SophyaPI/PIext/pipodrw.cc
===================================================================
--- trunk/SophyaPI/PIext/pipodrw.cc	(revision 563)
+++ trunk/SophyaPI/PIext/pipodrw.cc	(revision 584)
@@ -54,26 +54,4 @@
 }
 
-// ----------------------------------------------------------
-// Adaptateur de vecteurs Peida++ a P1DArrayAdapter
-// ----------------------------------------------------------
-
-/* --Methode-- */
-POVectorAdapter::POVectorAdapter(Vector* v, bool ad)
-        : P1DArrayAdapter(v->NElts())
-{
-aDel = ad; mVec = v;
-}
-
-/* --Methode-- */
-POVectorAdapter::~POVectorAdapter()
-{
-if (aDel) delete mVec;
-}
-
-/* --Methode-- */
-double POVectorAdapter::Value(int i)
-{ 
-return((*mVec)(i)); 
-}
 
 // ----------------------------------------------------------
@@ -99,4 +77,30 @@
 {
 return((*mH2d)(ix, iy));
+}
+
+
+#ifdef SANS_EVOLPLANCK
+
+// ----------------------------------------------------------
+// Adaptateur de vecteurs Peida++ a P1DArrayAdapter
+// ----------------------------------------------------------
+
+/* --Methode-- */
+POVectorAdapter::POVectorAdapter(Vector* v, bool ad)
+        : P1DArrayAdapter(v->NElts())
+{
+aDel = ad; mVec = v;
+}
+
+/* --Methode-- */
+POVectorAdapter::~POVectorAdapter()
+{
+if (aDel) delete mVec;
+}
+
+/* --Methode-- */
+double POVectorAdapter::Value(int i)
+{ 
+return((*mVec)(i)); 
 }
 
@@ -126,3 +130,4 @@
 }
 
+#endif   // SANS_EVOLPLANCK
 
Index: trunk/SophyaPI/PIext/pipodrw.h
===================================================================
--- trunk/SophyaPI/PIext/pipodrw.h	(revision 563)
+++ trunk/SophyaPI/PIext/pipodrw.h	(revision 584)
@@ -13,10 +13,6 @@
 
 #ifdef SANS_EVOLPLANCK
-#include "cvector.h"
-#include "matrix.h"
 class GeneralFunction;
 #else
-#include "tvector.h"
-#include "tmatrix.h"
 namespace SOPHYA {class GeneralFunction;} 
 #endif
@@ -36,15 +32,4 @@
 
 
-// Adaptateur de vecteurs Peida++ a P1DArrayAdapter
-class POVectorAdapter : public P1DArrayAdapter {
-public :
-                  POVectorAdapter(Vector* v, bool ad=false);
-  virtual         ~POVectorAdapter();
-  virtual double  Value(int i);
-
-protected:
-  bool aDel;
-  Vector* mVec;
-};
 
 // Adaptateur d'Histo-2D Peida++ a P2DArrayAdapter
@@ -59,4 +44,20 @@
   bool aDel;
   Histo2D* mH2d;
+};
+
+#ifdef SANS_EVOLPLANCK
+#include "cvector.h"
+#include "matrix.h"
+
+// Adaptateur de vecteurs Peida++ a P1DArrayAdapter
+class POVectorAdapter : public P1DArrayAdapter {
+public :
+                  POVectorAdapter(Vector* v, bool ad=false);
+  virtual         ~POVectorAdapter();
+  virtual double  Value(int i);
+
+protected:
+  bool aDel;
+  Vector* mVec;
 };
 
@@ -75,4 +76,5 @@
 };
 
+#endif   // SANS_EVOLPLANCK
 
 #endif
Index: trunk/SophyaPI/PIext/pisiadw.cc
===================================================================
--- trunk/SophyaPI/PIext/pisiadw.cc	(revision 563)
+++ trunk/SophyaPI/PIext/pisiadw.cc	(revision 584)
@@ -211,4 +211,13 @@
   { printf("ObjMgrWind::SetFile Exception= %ld (%s) \n", (long)merr, PeidaExc(merr)); 
   ok = false; } ENDTRY;
+#else
+try {
+  mPin = new PInPersist(flnm);
+  }
+catch (IOExc iox) {
+  cerr << "ObjMgrWind::SetFile/Error Exception - Msg= " << iox.Msg() << endl;
+  ok = false;
+  }
+#endif
 
 if (!ok) { mPin = NULL;  dap->SetReady(); return; }
@@ -220,5 +229,4 @@
   return;
 }
-#endif
 if (objlist)  delete objlist;
 SetSize(ttx,tty);
@@ -238,4 +246,10 @@
   objlist->AppendItem(strg, 5000+i);
 }
+#else
+string tn;
+for(i=0; i<mPin->NbTags(); i++) {
+  tn = mPin->GetTagName(i);
+  objlist->AppendItem(tn.c_str(), 5000+i);
+}
 #endif
 
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 563)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 584)
@@ -25,4 +25,5 @@
 #include "tmatrix.h"
 #include "tvector.h"
+#include "pitvmaad.h"
 #endif
 